﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Diagnostics;

namespace howto_ducci_sequence
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Return the numbers separated by dashes.
        private string NumsToString(List<int> nums)
        {
            return string.Join("-", nums.ConvertAll(n => n.ToString()).ToArray());
        }

        private void btnGo_Click(object sender, EventArgs e)
        {
            lstResults.DataSource = null;
            Refresh();

            // Convert into a List<int>.
            string nums_str = txtStart.Text;
            List<string> ints = nums_str.Split('-').ToList();
            List<int> nums = ints.ConvertAll(s => int.Parse(s));
            int nums_length = nums.Count;

            // Build the sequence.
            List<string> sequence = new List<string>();
            sequence.Add(NumsToString(nums));
            for (; ; )
            {
                List<int> new_nums = new List<int>();
                for (int i = 0; i < nums.Count; i++)
                    new_nums.Add(Math.Abs(nums[i] - nums[(i + 1) % nums_length]));
                nums = new_nums;

                nums_str = NumsToString(nums);
                if (sequence.Contains(nums_str))
                {
                    sequence.Add(nums_str);
                    int start = sequence.IndexOf(nums_str);
                    int length = sequence.Count - start;
                    lblSequenceStart.Text = start.ToString();
                    lblSequenceLength.Text = length.ToString();
                    lstResults.DataSource = sequence;
                    return;
                }
                sequence.Add(nums_str);

                Debug.Assert(sequence.Count < 10000);
            }
        }
    }
}
